package com.fr.plugin.cpic.utils;


import java.time.LocalDateTime;
import java.time.format.DateTimeFormatter;
import java.util.Calendar;
import java.util.Date;

public class DateUtils {

    /**
     * 返回当前时间
     *
     * @return
     */
    public static String getNowDateStr() {
        DateTimeFormatter df = DateTimeFormatter.ofPattern("yyyyMMdd");
        LocalDateTime date = LocalDateTime.now();
        return date.format(df);
    }

    /**
     * 返回1小时10分钟前时间
     *
     * @return
     */
    public static String get1h10mDateStr() {
        DateTimeFormatter df = DateTimeFormatter.ofPattern("yyyy-MM-dd HH:mm:ss.SSS");
        LocalDateTime date = LocalDateTime.now();
        date = date.minusHours(1).minusMinutes(10);
        return date.format(df);
    }

    /**
     * 返回昨天当前的时间
     *
     * @return
     */
    public static String getYesterdayDateStr() {
        DateTimeFormatter df = DateTimeFormatter.ofPattern("yyyy-MM-dd HH:mm:ss.SSS");
        LocalDateTime date = LocalDateTime.now();
        date = date.minusDays(1);
        return date.format(df);
    }

    /**
     * 返回N天当前的时间
     *
     * @return
     */
    public static String getYesterdayDateStr(int daynum) {
        DateTimeFormatter df = DateTimeFormatter.ofPattern("yyyy-MM-dd HH:mm:ss.SSS");
        LocalDateTime date = LocalDateTime.now();
        date = date.minusDays(daynum);
        return date.format(df);
    }

    /**
     * 返回今天的DATE
     *
     * @return
     */
    public static Date getNowDayDate() {
        Calendar calendar1 = Calendar.getInstance();
        calendar1.setTime(new Date());
        Calendar calendar2 = Calendar.getInstance();
        calendar2.set(Calendar.YEAR, calendar1.get(Calendar.YEAR));
        calendar2.set(Calendar.MONTH, calendar1.get(Calendar.MONTH));
        calendar2.set(Calendar.DATE, calendar1.get(Calendar.DATE));
        return calendar2.getTime();
    }

    /**
     * 返回一年后今天的DATE
     *
     * @return
     */
    public static Date getYearDayDate() {
        Calendar calendar1 = Calendar.getInstance();
        calendar1.setTime(new Date());
        Calendar calendar2 = Calendar.getInstance();
        calendar2.set(Calendar.YEAR, calendar1.get(Calendar.YEAR) + 1);
        calendar2.set(Calendar.MONTH, calendar1.get(Calendar.MONTH));
        calendar2.set(Calendar.DATE, calendar1.get(Calendar.DATE));
        return calendar2.getTime();
    }

}
